<?php
namespace Ak\Wp\Test;

use Psr\Container\ContainerInterface;
use Laminas\ServiceManager\ServiceManager;

/**
 * Alati za testiranje WordPress komponenti.
 *
 * @package Ak\Wp\Test
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/wp-test
 *
 * @method ServiceManager getContainer(array $config = [], array $services = [])
 */
trait WpTestTrait
{
    /**
     * Pokreće WordPress s datim containerom i vraća generiranu stranicu.
     *
     * @param ContainerInterface|null $container
     *
     * @return string
     */
    protected function runWordPress(ContainerInterface $container = null): string
    {
        $GLOBALS['container'] = $container = $container ?? $this->getContainer();

        require_once __DIR__ . '/wordpress/wp-init.php';

        $GLOBALS['wp_actions'] = [];

        ob_start();
        require __DIR__ . '/wordpress/wp-settings.php';

        wp();

        require ABSPATH  . WPINC . '/template-loader.php';
        return ob_get_clean();
    }
}
