<?php
/**
 * Inicijalizacija kompletnog testiranja.
 *
 * @var ContainerInterface $container;
 */

use Psr\Container\ContainerInterface;

// Inicijalizacija se smije izvršiti samo jednom.
if (defined('WP_TEST_INITIALIZED')) {
    return;
}

// Putanja do WordPressa

$projectPath = __DIR__;

while (!file_exists($projectPath . '/vendor/autoload.php')) {
    $projectPath = dirname($projectPath);
}

//$projectPath = dirname($projectPath);
$composerJsonPath = $projectPath . '/composer.json';

if (!file_exists($composerJsonPath)) {
    throw new RuntimeException("Ne mogu pronaći 'composer.json'.");
}

$composerJson = json_decode(file_get_contents($composerJsonPath), true);
$wordPressPath = $projectPath . '/' . ($composerJson['extra']['wordpress-install-dir'] ?? 'wordpress');

// WordPress konstante
$config = $container->get('config');

define('WP_USE_THEMES', true);

define('DB_NAME', $config['db']['database'] ?? 'test');
define('DB_USER', $config['db']['username'] ?? 'test');
define('DB_PASSWORD', $config['db']['password'] ?? '');
define('DB_HOST', $config['db']['hostname'] ?? 'localhost');
define('DB_CHARSET', 'utf8');
define('DB_COLLATE', 'utf8mb4_general_ci');

define('AUTH_KEY',         'put your unique phrase here');
define('SECURE_AUTH_KEY',  'put your unique phrase here');
define('LOGGED_IN_KEY',    'put your unique phrase here');
define('NONCE_KEY',        'put your unique phrase here');
define('AUTH_SALT',        'put your unique phrase here');
define('SECURE_AUTH_SALT', 'put your unique phrase here');
define('LOGGED_IN_SALT',   'put your unique phrase here');
define('NONCE_SALT',       'put your unique phrase here');

$GLOBALS['table_prefix'] = $table_prefix = 'wp_';

define('ABSPATH', $wordPressPath . '/');
define('WP_DEBUG', true);
define('WP_CONTENT_DIR', $projectPath . '/wp-content');
define('WP_PLUGIN_DIR', WP_CONTENT_DIR . '/plugins');

// Instalacija
$env = [];

foreach (['DB_NAME', 'DB_USER', 'DB_PASSWORD', 'DB_HOST'] as $constant) {
    $env[] = sprintf('%s=%s', $constant, constant($constant));
}

$installScripts = implode('|', $this->installScripts ?? []);

system(sprintf(
    '%s php %s %s',
    implode(' ', $env),
    escapeshellarg(__DIR__ . '/wp-install.php'),
    escapeshellarg($installScripts)
));

$GLOBALS['wp_plugin_paths'] = [];

define('WP_TEST_INITIALIZED', true);
